<template>
  <div class="p-2 flex h-screen w-screen items-center justify-center flex-col">
    <h1 class="text-4xl font-bold mb-1">{{ t("setup.wallet.title") }}</h1>
    <h2 class="text-xl mb-4">{{ t("setup.wallet.subtitle") }}</h2>

    <span v-if="step == 1" class="mb-4 max-w-xl text-center" v-html="type == Type.CREATE ? t('setup.wallet.create.seed') : t('setup.wallet.recover.seed')" />

    <div class="my-4" v-if="step == 1">
      <Seed :seed="seed?.wallet.randomSeed" v-if="type == Type.CREATE" v-model="seedInputIndex"/>
      <SeedInput v-model="seedValue" v-model:index="seedInputIndex" @submit="step = 2; doInitWallet()"
                 v-else-if="type == Type.RECOVER"/>
    </div>

    <span v-if="step == 2">{{ t("setup.wallet.wait") }}</span>

    <UModal v-model:open="modalOpen" v-if="step == 1">
      <UButton :disabled="seedInputIndex < seed?.wallet.randomSeed.length! - 1">Next
      </UButton>

      <template #content>
        <div class="bg-white dark:bg-slate-950 p-4 rounded flex flex-col gap-4 items-center justify-center">
          <UAlert
              color="warning"
              :title="t('setup.wallet.confirm-seed.title')"
              :description="t('setup.wallet.confirm-seed.description')"
              icon="i-heroicons-information-circle-20-solid"
          />
          <UButton @click="modalOpen = false;" size="xl">{{ t("utils.go-back") }}</UButton>
          <UButton @click="doInitWallet" :loading>{{ t("setup.wallet.confirm-seed.confirm") }}</UButton>
        </div>
      </template>
    </UModal>

    <UButton size="xl" @click="createWallet" class="mb-1" v-if="step == 0">{{
        t("setup.wallet.create.button")
      }}
    </UButton>
    <a @click="recoverWallet" v-if="step == 0">{{ t("setup.wallet.create.button") }}</a>
  </div>
</template>


<script setup lang="ts">
const {t} = useI18n();
const step = ref(0);
const seedInputIndex = ref(0);
const modalOpen = ref(false);
const loading = ref(false);
const seedValue = ref<string[]>([]);

enum Type {
  CREATE,
  RECOVER,
}

const type = ref<Type>(Type.CREATE);

const createWallet = () => {
  step.value = 1;
};

const recoverWallet = () => {
  seedValue.value = [];
  step.value = 1;
  type.value = Type.RECOVER;
};

const seedQuery = graphql(`
  query getSeed {
    wallet {
       randomSeed
    }
  }
`);

const {data: seed} = await useAsyncQuery(seedQuery);

watch(seed, () => {
  seedValue.value = seed?.value?.wallet?.randomSeed!;
});

seedValue.value = seed?.value?.wallet?.randomSeed || [];

const initWalletMutation = graphql(`
  mutation initWallet($seed: [String!]!) {
    initWallet(seed: $seed)
  }
`);

const initWallet = useMutation(initWalletMutation);

async function doInitWallet() {
  loading.value = true;
  await initWallet.mutate({
    seed: seedValue.value,
  });
  navigateTo("/init-wallet/done");
}
</script>
